from MeterPublish import MeterPublish
from RelaisSubscribe import RelaisSubscribe
from ModbusBase import ModbusHandler
from loguru import logger
from config import Config
import logging
import threading


l = logging.getLogger()
for h in l.handlers:
  l.removeHandler(h)

deathBell = threading.Event()

def exceptHook(args):
    global deathBell
    logger.error("Exception in thread caught: {}".format(args))
    deathBell.set()
    logger.error("rang the death bell")


logger.info("pv controller starting")

config = Config()

modbusHandler = ModbusHandler(config)

relaisSubscribeThread = RelaisSubscribe(config, modbusHandler)
relaisSubscribeThread.start()
logger.info("relaisSubscribe started")

meterPublishThread = MeterPublish(config, modbusHandler)
meterPublishThread.start()
logger.info("meterPublishThread started")

threading.excepthook = exceptHook
logger.info("Threading excepthook set")

logger.info("pv controller is running")


deathBell.wait()
logger.error("pv controller is dying")

relaisSubscribeThread.stop()
meterPublishThread.stop()

relaisSubscribeThread.join()
logger.error("relaisSubscribe joined")

meterPublishThread.join()
logger.error("meterPublishThread joined")

logger.error("pv controller is terminated")
